;==========================================================================
;  Anwendung:		TOR2-Verbindung (z.B. mit PC)
;
;	Autor:			E.Mueller
;
;	erstellt:		14.01.2007
;	gendert:		21.03.2008
;       
;	Prozessor:		U883
;	Takt:				8 MHz
;	geeignet fr:	JU+TE mit 4K Betriebssystem
;
;	Anschlu z.B. an PC
;
;  parallele                JU+TE
;  Schnittstelle            TOR2
;      D0 (2)  <---R100--->  P20
;      D1 (3)  <---R100--->  P21
;      D2 (4)  <---R100--->  P22
;      D3 (5)  <---R100--->  P23
;      D4 (6)  <---R100--->  P24	
;      D5 (7)  <---R100--->  P25
;      D6 (8)  <---R100--->  P26
;      D7 (9)  <---R100--->  P27
;   Masse (0)  <---------->  Masse
;
;==========================================================================

buchstabe	MACRO	wert
	ld	%5A,#wert
	call	%0827
	MACEND

	.org %2800
	jp	Anfang

zaehler	equ	%45
temp	equ	%46
temp_s	equ	%47
wert	equ	r8
endekenner	equ	%49


	;Warteschleife
Warte:
	push	rp
	srp	#%20
	ld	r0,#%ff
   ld	r1,#%0f		;ggf. erhhen, falls Probleme beim Senden auftreten (Empfang bei PC o..)
wam:
	djnz	r0,wam
   djnz	r1,wam
	pop	rp	
  	ret

Anfang:
	;Bereich voreinstellen
	ld	%40,#%E0
	ld	%41,#%0
	ld	%42,#%F7
	ld	%43,#%BF
Haupt:
	call	Z_Erste
	call	Z_Adresse
	call	Z_Letzte
	call	%0C1D	;Tastenabfrage
	cp	%5A,#'Z'
	jr	nz,stw1
	ret	;Rckkehr
stw1:
	cp	%5A,#'S'
	jr	nz,stw2
	call	Senden
	jp	Haupt
stw2:
	cp	%5A,#'E'
	jr	nz,stw3
	call	Z_Frage_Bereit
	call	%0C1D	;Tastenabfrage
	cp	%5A,#'N'
	jp	Z,Haupt
	call	Empfangen
	jp	Haupt
stw3:
	cp	%5A,#'B'
	jp	nz,Haupt
	call	Bereich
	jp	Haupt
	
Senden:
	ld	%4a,%40	;Sicherung oberer Teil Startadresse
	ld	%4b,%41	;Sicherung unterer Teil Startadresse
	ld	%f6,#%0	;Tor 2 als Ausgang
	di
	push rp
	srp #%40
	clr	P2	;auf Null setzen
	call Warte
	ld	P2,#%AA	;Anfang
	call Warte
	;********** KOPF ************
	push	%2f
	ld	%2f,%40
	call	Kopf_Adressbyte
	ld	%2f,%41
	call	Kopf_Adressbyte
	ld	%2f,%42
	call	Kopf_Adressbyte
	ld	%2f,%43
	call	Kopf_Adressbyte
	pop	%2f
	ld	P2,#%C3		;Trenner
	call Warte
	;********** ENDE KOPF ************
	incw	rr2		;Damit auch die letzte Postion kopiert wird !
sew1:
	ldc r15,@rr0		;Hole Daten von Adresse
	and	r15,#%f0	;oberer Teil
	swap	r15		;tauschen
	add 	r15,#%10		;Kennung oT laden
	ld	P2,r15		;Ausgabe
	call Warte
	ldc r15,@rr0		;Hole erneut Daten von Adresse
	and	r15,#%0f	;unterer Teil
	add	r15,#%20			;Kennung uT laden
	ld	P2,r15		;Ausgabe
	call Warte
	;Weiter
	incw rr0
	cp r2,r0
	jr nz,sew1	;oberer Teil nicht 0, dann weiter
	cp r3,r1
	jr nz,sew1	;unterer Teil nicht 0, dann weiter
	ld	P2,#%55	;Ende
	call Warte
	clr	P2		;auf Null setzen
	call Warte
	decw	rr2		;Was man verstellt mu man wieder richten
	pop rp
	ei
	ld	%f6,#%ff	;Tor 2 wieder als Eingang
	ld	%40,%4a	;Wiederherstellung oberer Teil Startadresse
	ld	%41,%4b	;Wiederherstellung unterer Teil Startadresse
	ret

Kopf_Adressbyte:
	ld	%4e,%2f		;arbeite mit siko
	and	%4e,#%f0	;oberer Teil
	swap	%4e		;tauschen
	ld	%4f,#%10		;Kennung oT laden
	add	%4f,%4e	;Verknpfen
	ld	P2,%4f		;Ausgabe
	call Warte
	ld	%4e,%2f		;arbeite mit siko
	and	%4e,#%0f	;unterer Teil
	ld	%4f,#%20		;Kennung uT laden
	add	%4f,%4e	;Verknpfen
	ld	P2,%4f		;Ausgabe
	call Warte
	ret	

Empfangen:
	;call	%8dd
	ld	%f6,#%ff	;Tor 2 als Eingang
	di
	push rp
	srp #%40
	;*** Kopf Anfang ***
	;Warte auf Anfang...
Empf_Weiter0:
	;---Abbruchmglichkeit !
	call	%0c56			;dynamische Tastenabfrage
	ld	wert,%6D
	and	wert,#01111111b	;T-Bit ausblenden
	cp	wert,#'A'
	jr	z,Empf_Weiter3
	cp	wert,#'X'
	jr	z,Empf_Weiter3
	;---Abbruchmglichkeit Ende
	cp	P2,#%AA			;Anfang
	jr	NZ,Empf_Weiter0
	;Weiter Start-,Stopadresse H
	call	Warte_auf_Byte
	ld	%40,wert	;Start		
	ld	%42,wert	;Stop
	;Weiter Start-,Stopadresse L
	call	Warte_auf_Byte
	ld	%41,wert	;Start			
	ld	%43,wert	;Stop
	;Stop -1
	decw	rr2
	;Warte auf Trenner...
Empf_Weiter1:
	;---Abbruchmglichkeit !
	call	%0c56			;dynamische Tastenabfrage
	ld	wert,%6D
	and	wert,#01111111b	;T-Bit ausblenden
	cp	wert,#'A'
	jr	z,Empf_Weiter3
	cp	wert,#'X'
	jr	z,Empf_Weiter3
	;---Abbruchmglichkeit Ende
	cp	P2,#%C3			;Trenner
	jr	NZ,Empf_Weiter1
	;*** Kopf Ende ***
	;Weiter Daten
Empf_Weiter2:
	call	Warte_auf_Byte
	cp		endekenner,#2	;Ende
	jr	Z,Empf_Weiter3
	incw	rr2
	lde	@rr2,wert
	jr	Empf_Weiter2
Empf_Weiter3:
	clr	%6d			;dynamisches Tasten-Register rcksetzen
	pop rp
	ei
	ret
	
	;Baut 1x und 2x zu einem Byte zusammen
Warte_auf_Byte:
	ld	endekenner,#1
	;---Abbruchmglichkeit !
	call	%0c56			;dynamische Tastenabfrage
	ld	r9,%6D
	and	r9,#01111111b	;T-Bit ausblenden
	cp	r9,#'A'
	jr	z,WaB_EndeZeichen
	cp	r9,#'X'
	jr	z,WaB_EndeZeichen
	;---Abbruchmglichkeit Ende
	;Warte auf 1
	ld	temp_s,P2
	ld	temp,temp_s
	;auf Ende-Zeichen berprfen
	cp	temp,#%55
	jr	Z,WaB_EndeZeichen
	;---
	swap	temp
	and	temp,#%0f
	cp	temp,#1
	jr	NZ,Warte_auf_Byte
	and	temp_s,#%0f
	swap	temp_s
	ld	wert,temp_s
	;Weiter, Warte auf 2
WaB_Weiter:
	;---Abbruchmglichkeit !
	call	%0c56			;dynamische Tastenabfrage
	ld	r9,%6D
	and	r9,#01111111b	;T-Bit ausblenden
	cp	r9,#'A'
	jr	z,WaB_EndeZeichen
	cp	r9,#'X'
	jr	z,WaB_EndeZeichen
	;---Abbruchmglichkeit Ende
	ld	temp_s,P2
	ld	temp,temp_s
	;auf Ende-Zeichen berprfen
	cp	temp,#%55
	jr	Z,WaB_EndeZeichen
	;---
	swap	temp
	and	temp,#%0f
	cp	temp,#2
	jr	NZ,WaB_Weiter
	and	temp_s,#%0f
	add	wert,temp_s
	ret	
WaB_EndeZeichen:
	ld	endekenner,#2
	ret	

Bereich:
	call	Z_Bereich1
	ld	%2A,#%24	;von
	call	Adresse_eingeben
	call	%0ACE	;neue Zeile
	buchstabe 'B'	
	buchstabe 'I'	
	buchstabe 'S'	
	buchstabe ':'	
	ld	%2A,#%26	;bis
	call	Adresse_eingeben
	call	Z_Bereich2
	call	%0C1D	;Tastenabfrage
	cp	%5A,#'J'
	jr	nz,bew1
	ld	%40,%24
	ld	%41,%25
	ld	%42,%26
	ld	%43,%27
bew1:
	ret

Z_Adresse:
	ld	%5E,%40
	ld	%5F,%41
	call	%20DB
	buchstabe '-'	
	ld	%5E,%42
	ld	%5F,%43
	call	%20DB
	call	%0ACE	;neue Zeile
	call	%0ACE	;neue Zeile
	ret

Z_Erste:
	push	r13
	push	r14
	push	r15
	ld	r15,#low	Z_Erste_Bild
	ld	r14,#high Z_Erste_Bild
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret
	
Z_Letzte:
	push	r13
	push	r14
	push	r15
	ld	r15,#low	Z_Letzte_Bild
	ld	r14,#high Z_Letzte_Bild
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret

Z_Frage_Bereit:
	push	r13
	push	r14
	push	r15
	ld	r15,#low	Z_Frage_Bild
	ld	r14,#high Z_Frage_Bild
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret

Z_Bereich1:
	push	r13
	push	r14
	push	r15
	ld	r15,#low	Z_Bereich1_Bild
	ld	r14,#high Z_Bereich1_Bild
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret

Z_Bereich2:
	push	r13
	push	r14
	push	r15
	ld	r15,#low	Z_Bereich2_Bild
	ld	r14,#high Z_Bereich2_Bild
	call	Baue_Bild
	pop	r15
	pop	r14
	pop	r13
	ret

Baue_Bild:
	ldc	r13,@rr14
	cp	r13,#%01
	jr	z,BB_W1
	cp	r13,#%02
	jr	z,BB_W2
	cp	r13,#%03
	jr	z,BB_W3
	;normales Zeichen
	ld	%5A,r13
	call	%0827
BB_W0:
	incw	rr14	
	jr	Baue_Bild
BB_W1:
	call	%08DD	;Bildschirm lschen
	jr		BB_W0
BB_W2:
	call	%0ACE	;neue Zeile
	jr		BB_W0
BB_W3:
	ret

Z_Frage_Bild:	
	;%01 Bildschirm lschen
	;%02 neue Zeile
	;%03 Ende
	db	%01
	.ascii "BILD WIRD NUN"
	.ascii "ABGESCHALTET!"
	db	%02
	.ascii "ABBRUCH DURCH"
	.ascii "TASTE A BZW X"
	db	%02
	.ascii "BEREIT(J/N)?"
	db %03

Z_Erste_Bild:
	db	%01
	.ascii "TOR2-VERBIND."
	db	%02
	.ascii "B BEREICH"
	db	%02,%03

Z_Letzte_Bild:
	.ascii "E EMPFANGEN"
	db	%02
	.ascii "S SENDEN"
	db %02
	.ascii "Z ZURUECK "
	db %03

Z_Bereich1_Bild:
	db	%01
	.ascii "BEREICH"
	db	%02
	.ascii "FESTLEGEN"
	db	%02,%02
	.ascii "VON:"
	db	%03

Z_Bereich2_Bild:
	db	%02,%02
	.ascii "UEBERNEHMEN?"
	db	%03

Taste_erkannt:
	ld	%5A,%22		;Darstellen	
	call	%0827
	ld	@%2F,%20	;Lade Zeichen in Zwischenspeicher
	dec	%2F			;Stellenzeiger Zwischenspeicher
	srp	#%20
	djnz	r3,Tastenabfrage
	rl	%2E	;1.Stelle
	rl	%2E
	rl	%2E
	rl	%2E
	and	%2E,#%F0
	rl	%2C	;3.Stelle
	rl	%2C
	rl	%2C
	rl	%2C
	and	%2C,#%F0
	add	%2E,%2D	;1.& 2.Stelle zusammenfhren
	add	%2C,%2B	;3.& 4.Stelle zusammenfhren
	ld	@%2A,%2E	;oberer Adressteil
	inc	%2A
	ld	@%2A,%2C	;unterer Adressteil
	ret	

Adresse_eingeben:
	ld	%23,#%04		;Stellenzhler auf 4
	ld	%2F,#%2E		;Stellenzeiger
Tastenabfrage:
	push	r13
	push	r14
	push	r15
Erl_Tast_W0:
	ld	r15,#low	Erlaubte_Tasten
	ld	r14,#high Erlaubte_Tasten
	call	%0C1D	;Tastenabfrage
	ld	%22,%5A
	clr	%20
Erl_Tast_W1:
	ldc	r13,@rr14
	cp	%22,r13
	jr	Z,Erl_Tast_W2
	inc	%20
	cp	%20,#16
	jr	Z,Erl_Tast_W0
	incw	rr14
	jr	Erl_Tast_W1
Erl_Tast_W2:
	pop	r15
	pop	r14
	pop	r13
	jp	Taste_erkannt

Erlaubte_Tasten:	
	.ascii "0123456789ABCDEF"

	
.end
